"{ Package: 'exept:regression' }"

"{ NameSpace: RegressionTests }"

Object subclass:#CompilerTest
	instanceVariableNames:'value'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-Regression'
!


!CompilerTest class methodsFor:'tests - constants'!

test_int1024
    ^ 1024

    "
     self test_int1024
    "

!

test_int1048576
    ^ 1048576
!

test_int128
    ^ 128

    "
     self test_int128
    "
!

test_int131072
    ^ 131072
!

test_int16384
    ^ 16384

    "
     self test_int16384
    "

!

test_int2048
    ^ 2048

    "
     self test_int2048
    "

!

test_int2097152
    ^ 2097152
!

test_int256
    ^ 256

    "
     self test_int256
    "

!

test_int262144
    ^ 262144
!

test_int32768
    ^ 32768

    "
     self test_int32768
    "

!

test_int4096
    ^ 4096

    "
     self test_int4096
    "

!

test_int512
    ^ 512

    "
     self test_int512
    "

!

test_int524288
    ^ 524288
!

test_int65536
    ^ 65536

    "
     self test_int65536
    "

!

test_int8192
    ^ 8192

    "
     self test_int8192
    "

!

test_intM128
    ^ -128
! !

!CompilerTest class methodsFor:'tests argument passing'!

ret0
    ^ 0

    "
     self ret0
     Time millisecondsToRun:[ 1000000 timesRepeat:[self ret0] ]  
    "
!

ret1
    ^ 1

    "
     self ret1
     1000000 timesRepeat:[self ret1]
     Time millisecondsToRun:[ 1000000 timesRepeat:[self ret1] ]    
    "
!

retArg1:arg
    ^ arg

    "
     self retArg1:1
     1000000 timesRepeat:[self retArg1:1]
     Time millisecondsToRun:[ 1000000 timesRepeat:[self retArg1:1] ]
    "
!

retArg2:arg1 _:arg2
    ^ arg2

    "
     self retArg2:1 _:2    
     1000000 timesRepeat:[self retArg2:1 _:2]
     Time millisecondsToRun:[ 1000000 timesRepeat:[self retArg2:1 _:2] ] 
    "
!

retArg3:arg1 _:arg2 _:arg3
    ^ arg3

    "
     self retArg3:1 _:2 _:3                      
     1000000 timesRepeat:[self retArg3:1 _:2 _:3] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self retArg3:1 _:2 _:3] ]  
    "
!

retArg4:arg1 _:arg2 _:arg3 _:arg4
    ^ arg4

    "
     self retArg4:1 _:2 _:3 _:4                     
     1000000 timesRepeat:[self retArg4:1 _:2 _:3 _:4] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self retArg4:1 _:2 _:3 _:4] ]  
    "
!

retArg5:arg1 _:arg2 _:arg3 _:arg4 _:arg5
    ^ arg5

    "
     self retArg5:1 _:2 _:3 _:4 _:5                    
     1000000 timesRepeat:[self retArg5:1 _:2 _:3 _:4 _:5] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self retArg5:1 _:2 _:3 _:4 _:5] ]  
    "
!

retLiteral1
    ^ 'hello'

    "
     self retLiteral1
     1000000 timesRepeat:[self retLiteral1]
     Time millisecondsToRun:[ 1000000 timesRepeat:[self retLiteral1] ]
    "
!

retM1
    ^ -1

    "
     self retM1
     1000000 timesRepeat:[self retM1]
     Time millisecondsToRun:[ 1000000 timesRepeat:[self retM1] ]    
    "
!

retSelf
    ^ self

    "
     self retSelf
     1000000 timesRepeat:[self retSelf]
     Time millisecondsToRun:[ 1000000 timesRepeat:[self retSelf] ]  
    "
! !

!CompilerTest methodsFor:'helpers'!

size
    ^ 1
!

value:something
    value := something
! !

!CompilerTest methodsFor:'tests - booleans'!

testAnd:arg1 _:arg2
    ^ arg1 & arg2

    "
     self new testAnd:true _:true.      
     self new testAnd:true _:false.     
     self new testAnd:false _:true.     
     self new testAnd:false _:false.    
     self new testAnd:false _:nil.      
     self new testAnd:true _:nil. 
     self new testAnd:nil _:false.
     self new testAnd:nil _:true.
     self new testAnd:1234 _:true.
     self new testAnd:1234 _:false.
     self new testAnd:true _:1234.   
     self new testAnd:false _:1234.  
    "
!

testNot1:arg
    ^ arg not

    "
     self new testNot1:true.   
     self new testNot1:false.
     self new testNot1:1234.
    "
!

testNot2:arg1 _:arg2
    ^ arg1 not & arg2 not

    "
     self new testNot2:true  _:true.   
     self new testNot2:false _:true.
     self new testNot2:true  _:false.
     self new testNot2:false _:false.

     self new testNot2:false _:1234.
     self new testNot2:true  _:1234.
     self new testNot2:1234  _:true.
     self new testNot2:1234  _:false.
     self new testNot2:1234  _:2345.
    "
!

testOr:arg1 _:arg2
    ^ arg1 | arg2

    "
     self new testOr:true _:true.      
     self new testOr:true _:false.     
     self new testOr:false _:true.     
     self new testOr:false _:false.    
     self new testOr:false _:nil.      
     self new testOr:true _:nil. 
     self new testOr:nil _:false.
     self new testOr:nil _:true.
     self new testOr:1234 _:true.
     self new testOr:1234 _:false.
     self new testOr:true _:1234.   
     self new testOr:false _:1234.  
    "
! !

!CompilerTest methodsFor:'tests - conditions'!

testIf1:val
    |x|

    x := #foo.
    x := (val == #CursorRight or:[val == #CursorDown]) ifTrue:[1].
    ^ x

    "
     self new testIf1:#CursorRight
     self new testIf1:#CursorDown
     self new testIf1:#Foo             
     self new testIf1:#CursorUp        
     self new testIf1:nil              
     self new testIf1:1             
    "
!

testIf2:val
    |x|

    x := #foo.
    x := (val == #CursorRight or:[val == #CursorDown]) ifTrue:1.
    ^ x

    "
     self new testIf2:#CursorRight
     self new testIf2:#CursorDown
     self new testIf2:#Foo          
     self new testIf2:#CursorUp     
     self new testIf2:nil           
     self new testIf2:1             
    "
!

testIf3:val
    |x|

    x := #foo.
    x := (val isInteger) ifTrue:1.
    ^ x

    "
     self new testIf3:#CursorRight
     self new testIf3:#CursorDown
     self new testIf3:#Foo          
     self new testIf3:#CursorUp     
     self new testIf3:nil           
     self new testIf3:1             
    "
!

testIf4:val
    ^ val isNil

    "
     self new testIf4:#CursorRight 
     self new testIf4:1             
     self new testIf4:nil             
    "
!

testIf4:val1 with:val2
    ^ (val1 == nil and:[val2 == nil])

    "
     self new testIf4:#CursorRight with:#CursorDown  
     self new testIf4:#CursorRight with:nil          
     self new testIf4:nil with:#CursorDown
     self new testIf4:nil with:nil
    "
!

testIf5:val
    ^ val isNil ifTrue:[1]

    "
     self new testIf5:#CursorRight 
     self new testIf5:1             
     self new testIf5:nil             
    "
!

testIf5:val1 with:val2
    ^ (val1 isNil and:[val2 isNil])

    "
     self new testIf5:#CursorRight with:#CursorDown  
     self new testIf5:#CursorRight with:nil          
     self new testIf5:nil with:#CursorDown
     self new testIf5:nil with:nil
    "
!

testIf6:val
    ^ val isNil ifTrue:1

    "
     self new testIf6:#CursorRight  
     self new testIf6:1             
     self new testIf6:nil             
    "
!

testIf6b:val
    val isNil ifTrue:1

    "
     self new testIf6b:#CursorRight  
     self new testIf6b:1             
     self new testIf6b:nil             
    "
!

testIf6c:val
    val isNil ifTrue:[1]

    "
     self new testIf6c:#CursorRight  
     self new testIf6c:1             
     self new testIf6c:nil             
    "
!

testIf6d:val
    ^ val isNil ifTrue:val

    "
     self new testIf6d:#CursorRight  
     self new testIf6d:1             
     self new testIf6d:nil             
    "
!

testIf6e:val
    ^ val isNil ifFalse:val

    "
     self new testIf6e:['hello']    
     self new testIf6e:('hello' asValue)  
     self new testIf6e:#CursorRight  
     self new testIf6e:1             
     self new testIf6e:nil             
    "
!

testIf7:val
    ^ val ? 1

    "
     self new testIf7:#CursorRight  
     self new testIf7:1             
     self new testIf7:nil             
    "
!

testIfElse1:val
    |x|

    x := (val == #CursorRight or:[val == #CursorDown]) ifTrue:[1] ifFalse:[-1].
    ^ x

    "
     self new testIfElse1:#CursorRight
     self new testIfElse1:#CursorDown
     self new testIfElse1:#Foo             
     self new testIfElse1:#CursorUp        
     self new testIfElse1:nil              
     self new testIfElse1:1             
    "
!

testIfElse2:val
    |x|

    x := (val == #CursorRight or:[val == #CursorDown]) ifTrue:1 ifFalse:-1.
    ^ x

    "
     self new testIfElse2:#CursorRight
     self new testIfElse2:#CursorDown
     self new testIfElse2:#Foo          
     self new testIfElse2:#CursorUp     
     self new testIfElse2:nil           
     self new testIfElse2:1             
    "
!

testIfElse3:val
    |x|

    x := (val == #CursorRight or:[val isInteger]) ifTrue:1 ifFalse:-1.
    ^ x

    "
     self new testIfElse3:#CursorRight 
     self new testIfElse3:#CursorDown  
     self new testIfElse3:#Foo          
     self new testIfElse3:#CursorUp     
     self new testIfElse3:nil           
     self new testIfElse3:1             
    "
!

testIfElse4:val
    |x|

    x := #foo.
    x := (val isInteger) ifTrue:1 ifFalse:-1.
    ^ x

    "
     self new testIfElse4:#CursorRight  
     self new testIfElse4:#CursorDown   
     self new testIfElse4:#Foo          
     self new testIfElse4:#CursorUp     
     self new testIfElse4:nil           
     self new testIfElse4:1             
    "
!

testIfElse5:val
    |x|

    x := #foo.
    x := val ifNil:1 ifNotNil:-1.
    ^ x

    "
     self new testIfElse5:#CursorUp     
     self new testIfElse5:nil           
     self new testIfElse5:1             
    "
!

testIfElse6:val
    |x|

    x := #foo.
    x := val ifNil:[1] ifNotNil:[-1].
    ^ x

    "
     self new testIfElse6:#CursorUp     
     self new testIfElse6:nil           
     self new testIfElse6:1             
    "
!

testIfElse7:val with:val1 with:val2
    |x|

    x := #foo.
    x := val ifNil:val1 ifNotNil:val2.
    ^ x

    "
     self new testIfElse7:#CursorUp with:1 with:2    
     self new testIfElse7:nil       with:1 with:2        
     self new testIfElse7:1         with:1 with:2        
    "
! !

!CompilerTest methodsFor:'tests - constant folding'!

testFloat_pi
    ^ Float pi
!

testFloat_unity
    ^ Float unity
!

testFloat_zero
    ^ Float zero
!

testSmalltalk_if_else_isSmalltalkX
    Smalltalk isSmalltalkX ifTrue:[
	^ 'yes'
    ] ifFalse:[
	^ 'no'
    ]
!

testSmalltalk_if_else_isVisualWorks
    Smalltalk isVisualWorks ifTrue:[
	^ 'yes'
    ] ifFalse:[
	^ 'no'
    ]
!

testSmalltalk_if_isSmalltalkX
    Smalltalk isSmalltalkX ifTrue:[
	^ 'yes'
    ].
    ^ 'no'
!

testSmalltalk_if_isSqueak
    Smalltalk isSqueak ifTrue:[
	^ 'yes'
    ].
    ^ 'no'
!

testSmalltalk_if_isVisualWorks
    Smalltalk isVisualWorks ifTrue:[
	^ 'yes'
    ].
    ^ 'no'
!

testSmalltalk_isSmalltalkX
    ^ Smalltalk isSmalltalkX
!

testSmalltalk_isSqueak
    ^ Smalltalk isSqueak
!

testSmalltalk_isVisualAge
    ^ Smalltalk isVisualAge
!

testSmalltalk_isVisualWorks
    ^ Smalltalk isVisualWorks
!

testUnaryFolding
    self testFloat_pi ~= (Float perform:#pi) ifTrue:[self halt].
    self testFloat_unity ~= (Float perform:#unity) ifTrue:[self halt].
    self testFloat_zero ~= (Float perform:#zero) ifTrue:[self halt].

    self testSmalltalk_isSmalltalkX ~= (Smalltalk perform:#isSmalltalkX) ifTrue:[self halt].
    self testSmalltalk_isSqueak ~= (Smalltalk perform:#isSqueak) ifTrue:[self halt].
    self testSmalltalk_isVisualWorks ~= (Smalltalk perform:#isVisualWorks) ifTrue:[self halt].
    self testSmalltalk_isVisualAge ~= (Smalltalk perform:#isVisualAge) ifTrue:[self halt].

    "
     self basicNew testUnaryFolding
    "
! !

!CompilerTest methodsFor:'tests - inlined'!

test_even:arg
    ^ arg even

    "
     self new test_even:nil               
     self new test_even:123
     self new test_even:122
     self new test_even:(100 factorial)
    "
!

test_isInteger:arg
    ^ arg isInteger

    "
     self new test_isInteger:nil               
     self new test_isInteger:123
     self new test_isInteger:(100 factorial)
    "
!

test_isNotInteger:arg
    ^ arg isInteger not

    "
     self new test_isNotInteger:nil               
     self new test_isNotInteger:123
     self new test_isNotInteger:(100 factorial)
    "
!

test_max1:arg1 _:arg2
    ^ arg1 max:arg2

    "
     self new test_max1:nil _:nil              
     self new test_max1:1 _:nil              
     self new test_max1:nil _:1              
     self new test_max1:1 _:2              
     self new test_max1:2 _:1              

     self new test_max1:1.0 _:nil              
     self new test_max1:nil _:1.0              
     self new test_max1:1.0 _:2.0              
     self new test_max1:2.0 _:1.0              

     self new test_max1:1.0 _:2              
     self new test_max1:2.0 _:1              
     self new test_max1:1 _:2.0              
     self new test_max1:2 _:1.0              
    "
!

test_max2:arg
    ^ 1 max:arg

    "
     self new test_max2:nil              
     self new test_max2:0       
     self new test_max2:1       
     self new test_max2:2       

     self new test_max2:0.0         
     self new test_max2:1.0         
     self new test_max2:2.0         
    "
!

test_max3:arg
    |var|

    var := Array new:10.
    ^ 1 max:arg

    "
     self new test_max3:nil              
     self new test_max3:0       
     self new test_max3:1       
     self new test_max3:2       

     self new test_max3:0.0         
     self new test_max3:1.0         
     self new test_max3:2.0         
    "
!

test_max4:arg
    |var|

    var := Array new:10.
    ^ arg max:1

    "
     self new test_max4:nil              
     self new test_max4:0       
     self new test_max4:1       
     self new test_max4:2       

     self new test_max4:0.0         
     self new test_max4:1.0         
     self new test_max4:2.0         
    "
!

test_min1:arg1 _:arg2
    ^ arg1 min:arg2

    "
     self new test_min1:nil _:nil              
     self new test_min1:1 _:nil              
     self new test_min1:nil _:1              
     self new test_min1:1 _:2              
     self new test_min1:2 _:1              

     self new test_min1:1.0 _:nil              
     self new test_min1:nil _:1.0              
     self new test_min1:1.0 _:2.0              
     self new test_min1:2.0 _:1.0              

     self new test_min1:1.0 _:2              
     self new test_min1:2.0 _:1              
     self new test_min1:1 _:2.0              
     self new test_min1:2 _:1.0              
    "
!

test_min2:arg
    ^ 1 min:arg

    "
     self new test_min2:nil              
     self new test_min2:0       
     self new test_min2:1       
     self new test_min2:2       

     self new test_min2:0.0         
     self new test_min2:1.0         
     self new test_min2:2.0         
    "
!

test_min3:arg
    |var|

    var := Array new:10.
    ^ 1 min:arg

    "
     self new test_min3:nil              
     self new test_min3:0       
     self new test_min3:1       
     self new test_min3:2       

     self new test_min3:0.0         
     self new test_min3:1.0         
     self new test_min3:2.0         
    "
!

test_min4:arg
    |var|

    var := Array new:10.
    ^ arg min:1

    "
     self new test_min4:nil              
     self new test_min4:0       
     self new test_min4:1       
     self new test_min4:2       

     self new test_min4:0.0         
     self new test_min4:1.0         
     self new test_min4:2.0         
    "
!

test_odd:arg
    ^ arg odd

    "
     self new test_odd:nil               
     self new test_odd:123   
     self new test_odd:122     
     self new test_odd:(100 factorial)  
    "
!

test_size
    ^ value size

    "
     (self new value:(Array new:2)) test_size
     (self new value:(OrderedCollection new:2)) test_size
    "
! !

!CompilerTest methodsFor:'tests - sends'!

m1
    ^ 123
!

m10
    ^ self m9

    "
     self new m10
    "
!

m11
    ^ self m10

    "
     self new m11
    "
!

m12
    ^ self m11

    "
     self new m12
    "
!

m13
    ^ self m12

    "
     self new m13
    "
!

m14
    ^ self m13

    "
     self new m14
    "
!

m15
    ^ self m14

    "
     self new m15
    "
!

m16
    ^ self m15

    "
     self new m16
    "
!

m2
    ^ self m1
!

m3
    ^ self m2
!

m4
    ^ self m3
!

m5
    ^ self m4
!

m6
    ^ self m5
!

m7
    ^ self m6

    "
     self new m7
    "
!

m8
    ^ self m7

    "
     self new m8
    "
!

m9
    ^ self m8

    "
     self new m9
    "
! !

!CompilerTest methodsFor:'tests context setup'!

retArgWithFrameA:arg
    |a b c|

    a := 0.
    b := 1.
    c := 2.
    ^ arg

    "
     self new retArgWithFrameA:999                
    "
!

retArgWithFrameB:arg
    |a b c|

    a := 0.
    b := 1.
    c := 2.
    self retSelf.

    ^ arg

    "
     self new retArgWithFrameB:9999           
    "
!

retLocal
    |a|

    a := 0.
    ^ a

    "
     self new retLocal                    
     1000000 timesRepeat:[self new retInstVar] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self new retInstVar] ]  
    "

    "
     |i|

     i := self new.
     i instVarAt:1 put:12345.
     i retInstVar  
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     1000000 timesRepeat:[i retInstVar] 
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     Time millisecondsToRun:[ 1000000 timesRepeat:[i retInstVar] ]  
    "


!

retLocalB
    |a b c|

    a := 0.
    b := 1.
    c := 2.
    ^ a

    "
     self new retLocalB                    
     1000000 timesRepeat:[self new retLocalB] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self new retInstVar] ]  
     Time millisecondsToRun:[ 1000000 timesRepeat:[self new retLocalB] ]  
    "

    "
     |i|

     i := self new.
     i instVarAt:1 put:12345.
     i retInstVar  
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     1000000 timesRepeat:[i retInstVar] 
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     Time millisecondsToRun:[ 1000000 timesRepeat:[i retInstVar] ]  
    "


!

retLocalC
    |a b c|

    a := 0.
    b := 1.
    c := 2.
    ^ b

    "
     self new retLocalC                   
     1000000 timesRepeat:[self new retInstVar] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self new retInstVar] ]  
    "

    "
     |i|

     i := self new.
     i instVarAt:1 put:12345.
     i retInstVar  
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     1000000 timesRepeat:[i retInstVar] 
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     Time millisecondsToRun:[ 1000000 timesRepeat:[i retInstVar] ]  
    "


!

retLocalD
    |a b c|

    a := 0.
    b := 1.
    c := 2.
    ^ c

    "
     self new retLocalD                 
     1000000 timesRepeat:[self new retInstVar] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self new retInstVar] ]  
    "

    "
     |i|

     i := self new.
     i instVarAt:1 put:12345.
     i retInstVar  
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     1000000 timesRepeat:[i retInstVar] 
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     Time millisecondsToRun:[ 1000000 timesRepeat:[i retInstVar] ]  
    "


!

retLocalE
    |a b c|

    a := 0.
    b := 1.
    c := 2.
    ^ self

    "
     self new retLocalE                
     1000000 timesRepeat:[self new retInstVar] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self new retInstVar] ]  
    "

    "
     |i|

     i := self new.
     i instVarAt:1 put:12345.
     i retInstVar  
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     1000000 timesRepeat:[i retInstVar] 
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     Time millisecondsToRun:[ 1000000 timesRepeat:[i retInstVar] ]  
    "


!

retLocalF
    |a b c|

    a := 0.
    b := 1.
    c := 2.
    self retSelf.

    ^ a

    "
     self new retLocalF               
    "



!

retLocalG
    |a b c|

    a := 0.
    b := 1.
    c := 2.
    self retSelf.

    ^ b

    "
     self new retLocalG              
    "



!

retLocalH
    |a b c|

    a := 0.
    b := 1.
    c := 2.
    self retSelf.

    ^ c

    "
     self new retLocalH           
    "



!

retSelf


!

testContextA
    ObjectMemory dumpObject:thisContext

    "
     self new testContextA                    
    "

!

testContextB
    ObjectMemory dumpObject:thisContext sender

    "
     self new testContextB                   
    "

!

testContextC
    thisContext fullPrintAll

    "
     self new testContextC                 
    "

!

testContextD
    self testContextB

    "
     self new testContextD                
    "

!

testContextE
    ^ thisContext sender

    "
     self new testContextE               
    "

!

testContextF
    ^ self testContextE

    "
     self new testContextF              
    "

!

testSend0
    ^ 9999
!

testSend0B:arg
    ^ arg
!

testSend1
    ^ self testSend0

    "
     self new testSend1                    
    "

!

testSend1B
    ^ self testSend0B:1234

    "
     self new testSend1B                    
    "

!

testSend1C:arg
    ^ self testSend0B:arg

    "
     self new testSend1C:9998                   
    "
!

testSend2
    self testContextB

    "
     self new testSend2                   
    "

!

testSend3
    self testContextC

    "
     self new testSend3                   
    "

! !

!CompilerTest methodsFor:'tests entry'!

ilcMissCheck



    "
     (Array with:self new with:nil) do:[:el | el size printCR.].                    
    "



! !

!CompilerTest methodsFor:'tests instvar access'!

retInstVar
    ^ value

    "
     self new retInstVar                    
     1000000 timesRepeat:[self new retInstVar] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self new retInstVar] ]  
    "

    "
     |i|

     i := self new.
     i instVarAt:1 put:12345.
     i retInstVar  
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     1000000 timesRepeat:[i retInstVar] 
    "

    "
     |i|
     i := self new.
     i instVarAt:1 put:12345.
     Time millisecondsToRun:[ 1000000 timesRepeat:[i retInstVar] ]  
    "


!

setInstVarA
    value := 123

    "
     self new setInstVarA; instVarAt:1                    
     1000000 timesRepeat:[self new setInstVarA] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self new setInstVarA] ]  
    "

    "
     |i|

     i := self new.
     i instVarAt:1 put:12345.
     i setInstVarA.
     i instVarAt:1  
    "



!

setInstVarB
    value := 'hello'

    "
     self new setInstVarB; instVarAt:1                    
     1000000 timesRepeat:[self new setInstVarB] 
     Time millisecondsToRun:[ 1000000 timesRepeat:[self new setInstVarB] ]  
    "

    "
     |i|

     i := self new.
     i instVarAt:1 put:12345.
     i setInstVarB.
     i instVarAt:1          
    "



! !

!CompilerTest class methodsFor:'documentation'!

version
    ^ '$Header$'
! !
